// File: MinusNode.java
import antlr.*;
import antlr.collections.AST;

public class MinusNode extends BinaryOperatorAST {

  public MinusNode(Token token) {
    super(token);
  }

  public int getType() {
    return CalcParserTokenTypes.MINUS;
  }

  public String toString() {
    return " -";
  }

  public int value() {
    if (left() == null) {
      System.out.println("Error: MinusNode (no operands)!");
      return 0;
    }

    int val = left().value();
    if (right() != null) { // binary plus
      val -= right().value();
    } else { // unary minus
      val = -val;
    }
    return val;
  }

} // class MinusNode

