// File: PlusNode.java
import antlr.*;
import antlr.collections.AST;

public class PlusNode extends BinaryOperatorAST {

  public PlusNode(Token token) {
    super(token);
  }

  public int getType() {
    return CalcParserTokenTypes.PLUS;
  }

  public String toString() {
    return " +";
  }

  public int value() {
    if (left() == null) {
      System.out.println("Error: PlusNode (no operands)!");
      return 0;
    }

    int val = left().value();
    if (right() != null) { // binary plus
      val += right().value();
    }
    return val;
  }

} // class PlusNode

