
 
import java.io.*;
import java.util.*;


import javax.xml.transform.*;
import javax.xml.transform.sax.*;
import javax.xml.transform.stream.*;
import org.xml.sax.*;

import antlr.*;
import antlr.*;
import antlr.collections.*;
import antlr.collections.impl.*;

 
/**
* Shows how to use the CSVXMLReader class. 
* This is a command-line utility that takes 
* a CSV file and optionally an XSLT file as
* command line parameters. A transformation 
* is applied and the output is sent to 
* System.out.
*/
public class SimpleCSVProcessor  implements JavaTokenTypes {

	private final static int ROOT_ID = 0;
	private static String[] tokenNames;
	static StringBuffer sbuf = new StringBuffer();
	private static String filePath = "d:\\BRE\\poc\\genxml\\rules\\";
	private static String ruleExtn = ".xml";
	private static String filePathXsl = "d:\\BRE\\poc\\genxml2\\";
	static String xsltFileName = null;

  public static void main(String[] args) throws Exception {
    if (args.length == 0) {
      System.err.println("Usage: java "
          + SimpleCSVProcessor.class.getName( )
          + " <csvFile> [xsltFile]");
      System.err.println(" - csvFile is required");
      System.err.println(" - xsltFile is optional");
      System.exit(1);
    }
 
 //   String csvFileName = args[0];
	String conditionFile = args[0];

    xsltFileName = "ident.xsl";

	File xslFile = new File(xsltFileName);

	System.out.println(" xslt exists = " +  xslFile.exists());


	System.setProperty("javax.xml.transform.TransformerFactory", "com.icl.saxon.TransformerFactoryImpl");
//	System.setProperty("javax.xml.transform.TransformerFactory", "com.sun.org.apache.xalan.internal.processor.TransformerFactoryImpl");
//	System.setProperty("javax.xml.transform.TransformerFactory", "org.apache.xalan.processor.TransformerFactoryImpl");

	System.out.println(" xslt proc = " +  System.getProperty("javax.xml.transform.TransformerFactory"));
 
    TransformerFactory transFact = TransformerFactory.newInstance( );

		System.out.println(" xslt proc type= " +  transFact.getClass().getName());
 
    if (transFact.getFeature(SAXTransformerFactory.FEATURE)) {
      SAXTransformerFactory saxTransFact =
          (SAXTransformerFactory) transFact;
      TransformerHandler transHand = null;
      if (xsltFileName == null) {
        transHand = saxTransFact.newTransformerHandler( );
      } else {

			System.out.println(" in else xslt " +  xsltFileName);

        transHand = saxTransFact.newTransformerHandler(
            new StreamSource(new File(xsltFileName)));
      }
 

    
	int NUMRULES = 3;
	StringBuffer sbuf = new StringBuffer();

    // Open output as input
    Reader reader =  new FileReader(conditionFile);
				
	BufferedReader bufferedReader =
	        new BufferedReader(reader);


    // hook the CSVXMLReader to the CSV file
    CSVXMLReader csvReader = new CSVXMLReader();



	int count = 0;
	// Read input
	String line;
	while ((line = bufferedReader.readLine()) != null) {

		StringTokenizer stok = new StringTokenizer(line, ",");
		String ruleId = null;
		String cond = null;
		while(stok.hasMoreTokens()) {
		
		//	rule = stok.nextToken();
			
		//	if(rule.startsWith("#"))
		//		break;
		
			cond = stok.nextToken();			
			
			ruleId = "rule" + prefixZeros(count);
			
		
			System.out.println(" condition = " + cond);

			stok.nextToken();		
		}

			JavaEmitter jemit = new JavaEmitter();
			jemit.parseExpression(cond);

			String astCond = jemit.getASTExpression();

			InputSource csvInputSrc = new InputSource(new StringReader(astCond));
 


			FileOutputStream fout = new FileOutputStream(new File(filePath + ruleId + ruleExtn));


			System.out.println(" in else xslt " +  xsltFileName);

	  //      transHand = saxTransFact.newTransformerHandler(
	//		        new StreamSource(xslFile));

			transHand = saxTransFact.newTransformerHandler( );
     

	//		transHand.getTransformer().setOutputProperty("indent", "yes");

     //       transHand.getTransformer().setOutputProperty("{ http://xml.apache.org/xslt }indent-amount", "2");

			transHand.getTransformer().setOutputProperty(OutputKeys.INDENT, "yes");
        //    transHand.getTransformer().setOutputProperty("{ http://xml.apache.org/xslt }indent-amount", "2");


			// set the destination for the XSLT transformation
			transHand.setResult(new StreamResult(fout));

			System.out.println(" calling parse ");

 		    // attach the XSLT processor to the CSVXMLReader
			System.out.println(" setting Con Hnd = ");
			csvReader.setContentHandler(transHand);


//		    csvReader.parse(csvInputSrc);
			csvReader.parse(ruleId, astCond);

			count++;

    } 
	
	
	} else {
      System.err.println("SAXTransformerFactory is not supported.");
      System.exit(1);
    }
  }

	public static String prefixZeros(int id) {

		String idstr = Integer.toString(id);
		if (idstr.length() == 1) {
			idstr = "00" + idstr;
			return idstr;
		} else if(idstr.length() == 2) {
			idstr = "0" + idstr;
			return idstr;
		} else
			return idstr;
		
	}




}

