package xbeans;

import groovy.lang.GroovyClassLoader;
import groovy.lang.GroovyObject;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Source;
import javax.xml.transform.dom.DOMResult;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;


import groovy.r5;


public class ScriptRunnerInline {

	public static void main (String[] args) throws Exception {

	ClassLoader parent = ScriptRunnerLoader.class.getClassLoader(); 
	GroovyClassLoader loader = new GroovyClassLoader(parent); 
	
	Vector vec = new Vector();
	String ruleDir	= "d:\\BRE\\poc\\groovy";
	GroovyObject groovyObject = null;
	
	HashMap cacheMap = new HashMap();
	cacheMap.put("a", new Integer(100));
	cacheMap.put("b", new Integer(200));
	cacheMap.put("c", new Integer(150));
	
		
	try {
		
		Document xmldoc = null;
//		Document xsldoc = null;
//		Document xsddoc = null;
		String ruleName = null;
		
		String condition = null;
		Object [] ruleObj = null;
		
		 try {
            DocumentBuilderFactory factory =
                DocumentBuilderFactory.newInstance();
             factory.setIgnoringElementContentWhitespace(true);
               DocumentBuilder builder = factory.newDocumentBuilder();
               
               xmldoc = builder.parse( new File(args[0]) );

           //    xsddoc = builder.parse( new File(args[1]) );
               
           //    xsldoc = builder.parse( new File(args[2]) );

				System.out.println(" fin parsing ");
               
            } catch (SAXParseException spe) {
               /* Error generated by the parser */
             /*  System.out.println("\n** Parsing error"
                  + ", line " + spe.getLineNumber()
                  + ", uri " + spe.getSystemId());
    		
               System.out.println("   " + spe.getMessage() );
    		*/
               /* Use the contained exception, if any */
               Exception  x = spe;
               if (spe.getException() != null)
                   x = spe.getException();
               x.printStackTrace();
     
            } catch (SAXException sxe) {
               /* Error generated during parsing) */
               Exception  x = sxe;
               if (sxe.getException() != null)
                   x = sxe.getException();
               x.printStackTrace();
            } catch (ParserConfigurationException pce) {
                /* Parser with specified options can't be built */
                pce.printStackTrace();
            } catch (IOException ioe) {
               ioe.printStackTrace();
            }
		
		
    		try {

    			NodeList ruleList = xmldoc.getElementsByTagName("rul:rule");

				System.out.println(" Nodelist len " + ruleList.getLength());
				
				ruleObj = new Object[ruleList.getLength()];

    			for(int j=0;j<ruleList.getLength();j++) {
    	
    				System.out.println(" rule for ");

    				Vector vcond = new Vector();	
    				Vector params = new Vector();
    				
    				Node rule = ruleList.item(j);
    				
    				NamedNodeMap nmp = rule.getAttributes();
    				
    				
        			for(int k=0;k<nmp.getLength();k++) {
        				Node attr = nmp.item(k);
        				
        				System.out.println(" attr name " + attr.getNodeName());
        				
        				if(attr.getNodeName().equals("name")) {	
        					ruleName = attr.getNodeValue();
        					vcond.add(ruleName);
        					System.out.println(" rule name " + ruleName);
        				}		
        			}
    			
        			JAXPNodeEvaluator neval = new JAXPNodeEvaluator(xmldoc);
        			
					System.out.println("/rules/rule[@name='" + ruleName + "']//strvalue");
        			
					ArrayList alist = neval.evalXPath("/rules/rule[@name='" + ruleName + "']//variable");

					System.out.println(" alist = " + alist);

				HashMap varNameHash = null;		
				Vector varValVec = new Vector();
    			for(int r=0;r<alist.size();r++) {
    				
    				Node vnode = (Node) alist.get(r);
    				Object varName = null;	
    				String varVal = vnode.getFirstChild().getNodeValue();
    
    				if(vnode.getNodeName().equals("rul:variable"))	
    					varName = varVal.trim();
    				
    				if(varNameHash == null) {
    					varNameHash = new HashMap();
    					varNameHash.put(varName, "");
    					varValVec.add(cacheMap.get(varName));
    				} else if(!varNameHash.containsKey(varName)) {
    					varNameHash.put(varName, "");
    					varValVec.add(cacheMap.get(varName));
    				}
    			}
    			
    			for(int w=0;w<varValVec.size();w++) {
    				params.add(varValVec.get(w));
    			}
    			
    			vcond.add(params);
    		
    			
				vcond.add(condition);
				
				vec.add(vcond);

    			}
    			
    			} catch(Exception e) {
    				e.printStackTrace();
    			}
	
		
		long [] avgTime = new long[5];
		long [] totTime = new long[1];

//		for(int m=0;m<5;m++) {

		
		for(int s=0;s<vec.size();s++) {

			for(int k=0;k<100;k++) {
			
				long timeBef = System.currentTimeMillis();
		
			Vector vc = (Vector) vec.get(s);
			String rname = (String) vc.get(0);
			Vector vect = (Vector) vc.get(1);
			String cond = (String) vc.get(2);
			
			Object [] ps = vect.toArray();

			System.out.println(" time mid = " + (System.currentTimeMillis() - timeBef)); 

			
		//	System.out.println(" params array sz = " + ps.length);
		
		//	File f = new File(ruleDir + File.separator + rname + ".groovy");
			
		//	Class groovyClass = loader.parseClass(f);
			
			r5 r5inst = new r5();
			
			
			r5inst.invokeMethod("evaluate", ps);
			
		//	groovyObject = (GroovyObject) ruleObj[s];
			
			System.out.println(" time mid 1 = " + (System.currentTimeMillis() - timeBef)); 

			//Class groovyClass = loader.parseClass(groovyFile); 

		//	groovyObject = (GroovyObject) groovyClass.newInstance(); 
					
		//	String groovyFile = ruleDir + File.separator + rname + ".class";

	//		Object [] argz = ps;

	//		Object obj = groovyObject.invokeMethod("evaluate", argz); 	

	//		System.out.println("res = " + obj); 

			long timeAft = System.currentTimeMillis();


			System.out.println(" time aft = " + (timeAft - timeBef)); 

			totTime[k] =  timeAft - timeBef;
				
			}
			
			avgTime[s] = sum(totTime)/100;
		}
		
		
		
		
		for(int i=0;i<5;i++) {	
			System.out.println("avg time for cond  " + i + " = " + avgTime[i]);
		} 
				
	//	}			
    			
		

		} catch(Exception e) {
			e.printStackTrace();
		} finally {
		
	
		}

	
	}

	public static long sum(long [] la) {
	
		long sum = 0L;
		
		for(int r=0;r<la.length;r++)
			sum += la[r];
	
		return sum;
	}	
	
}
