<?xml version='1.0'?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  xmlns:rul="http://www.ruleml.org">
		 <xsl:output method="text" encoding="utf-8"/>
		 
	<xsl:strip-space elements="*"/>	 


		 <!--Look in the Results-->
		 <xsl:template match="/rul:rules">
		 		 		 <xsl:apply-templates
select="rul:rule"/>
		 </xsl:template>

		 
		 <!--Process each rule -->
		 <xsl:template match="rul:rule">

	<rul:rule name="{@name}">
<xsl:variable name="cond">
 <xsl:apply-templates select="rul:condition"/>	    
 </xsl:variable>
 
 
 <xsl:value-of select="normalize-space($cond)"/>	    
	    </rul:rule>
	    
	    
	    
	 </xsl:template>

        <xsl:template match="rul:sum">
	
  <xsl:apply-templates select="rul:leftbrace"/>	    
            
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'+'"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    

  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:sub">
            
        <xsl:apply-templates select="rul:leftbrace"/>	    
      
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'-'"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:mul">
 
 <xsl:apply-templates select="rul:leftbrace"/>	    
  
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'*'"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:div">
 
 <xsl:apply-templates select="rul:leftbrace"/>	    
  
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'/'"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:gt">
 
 <xsl:apply-templates select="rul:leftbrace"/>	    
   
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'>='"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:lt">
 
 <xsl:apply-templates select="rul:leftbrace"/>	    
  
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'&lt;='"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:eq">
 <xsl:apply-templates select="rul:leftbrace"/>	    
  
 
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'=='"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:gteq">
 <xsl:apply-templates select="rul:leftbrace"/>	    
  
 
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'>='"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>

        <xsl:template match="rul:lteq">
 <xsl:apply-templates select="rul:leftbrace"/>	    
  
 
 <xsl:apply-templates select="rul:leftparam"/>	    
 <xsl:value-of select="'&lt;='"/>	    
 <xsl:apply-templates select="rul:rightparam"/>	    
  
  <xsl:apply-templates select="rul:rightbrace"/>	    
             
     </xsl:template>


        <xsl:template match="rul:leftparam">
            <xsl:choose>
                <xsl:when test="variable"> 
                    <xsl:value-of select="variable"/>
                  </xsl:when>
                <xsl:when test="constant">
                    <xsl:value-of select="constant"/>
                  </xsl:when>
                 <xsl:otherwise>
					 <xsl:apply-templates />	    
                  </xsl:otherwise>
                </xsl:choose>
                
     </xsl:template>
     
        <xsl:template match="rul:leftbrace">
                    <xsl:value-of select="."/>
     </xsl:template>

        <xsl:template match="rul:rightbrace">
         <xsl:value-of select="."/>
     </xsl:template>
     
        <xsl:template match="rul:rightparam">
            <xsl:choose>
                <xsl:when test="rul:strvalue or rul:intvalue">
                    <xsl:value-of select="rul:strvalue"/>
                    <xsl:value-of select="rul:intvalue"/>
                  </xsl:when>
                 <xsl:otherwise>
	 <xsl:apply-templates />	    
                  </xsl:otherwise>
                </xsl:choose>
                
     </xsl:template>
     



</xsl:stylesheet>		 						 		 		 		 		 		 		 		    					    		 		     		 		 		 		 		 		 				 		 		     		           	 		                                                   	 		 