/**
 * <p>Title: Orbi-Credit</p>
 * <p>Description: Interface</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Orbitech Solutions Ltd</p>
 * @author Karthik.K
 * @version 1.0
 */

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.Stack;
import java.util.StringTokenizer;
import java.util.Vector;
public class FormulaEvaluator
{
    private InputMessage message= null;
    private static int LOGICAL= 10;
    private static final int RELATIONAL= 20;
    private static final int ARITHMETIC= 30;
    private static final int GEOMETRIC= 40;
    private static final int MODULUS= 50;
    private static final int EXPONENT= 60;
 
    private static final String STRING_SYMBOL= "'";

    private static final char STRING_SYMBOL_CHAR= '\'';
    private static final String DATE_SYMBOL= "'";
    private static final char DATE_SYMBOL_CHAR= '\'';
    private static boolean VERBOSE= true;
    private static final String DATE_FORMAT= "MM/dd/yyyy HH:mm:ss";
    private static final String DATE_ONLY_FORMAT=
        RuleEngineConstants.DATEFORMAT;
    //"MM/dd/yyyy";
    private String INDENT= "";
    private static final char VARIABLE_SYMBOL= '&';
    private static boolean DISPLAY_TIME_TAKEN= true;
    public FormulaEvaluator(InputMessage message) throws InterfaceException
    {
        this.message= message;
    }
    public String evaluate(String Condition) throws InterfaceException
    {
        return evaluateFormula(Condition, null, null);
    }
    public String evaluate(String Condition, HashMap VarMap)
        throws InterfaceException
    {
    	//stem.out.println("Enter the Formula Evaluator*******");
        return evaluateFormula(Condition, VarMap,null);
    }
    public String evaluate(String Condition, HashMap VarMap, Integer Occurance)
        throws InterfaceException
    {
        return evaluateFormula(Condition, VarMap, Occurance);
    }
    private String evaluateFormula(String Infix, HashMap map, Integer Occur) throws InterfaceException
    {
//		log("Enter the Formula Evaluator &&&&&&&&");
        Vector vt= format(Infix, map, Occur);
		log("Enter the Formula Evaluator vt" + vt);
		String result= null;
        for (int i= 0; i < vt.size(); i++)
        {
            String str= (String) vt.elementAt(i);
			log("Enter the Formula Evaluator str ::: " + str);
            if (str.startsWith("isNull"))
            {
                vt.setElementAt(isNull(str.substring(7, str.length() - 1), map, Occur) + "",i);
		    }
            else if (str.startsWith("nvl"))
            {
                vt.setElementAt(getNvl(str.substring(4, str.length() - 1), map, Occur) + "",i);
		    }
            else if (str.startsWith("toNum"))
            {
                vt.setElementAt(toNum(str.substring(6, str.length() - 1), map, Occur) + "",i);
		    }
            else if (str.startsWith("min("))
            {
                vt.setElementAt(getMin(str.substring(4, str.length() - 1), map, Occur) + "",i);
		    }
            else if (str.startsWith("addDate"))
            {
                vt.setElementAt(
                    addDate(str.substring(8, str.length() - 1), map, Occur),
                    i);
            }
            else if (str.startsWith("dateDiff"))
            {
                vt.setElementAt(
                    getDateDiff(str.substring(9, str.length() - 1), map, Occur),
                    i);
            }
            //INDENT=INDENT.substring(0,INDENT.length()-2);
        }
        result= eval(vt);
        log(" Result Return After Evaluate "+result);
		return result;
    }
    private Vector toPostFix(Vector vtInfix)
    {
        Vector vtResult= new Vector();
        Stack stack= new Stack();
        stack.push("#");
        Enumeration enumTokens= vtInfix.elements();
        while (enumTokens.hasMoreElements())
        {
            String input= (String) enumTokens.nextElement();
            if (input.equals("("))
            {
                stack.push(input);
            }
            else if (input.equals(")"))
            {
                String operator= (String) stack.pop();
                while (!operator.equals("("))
                {
                    vtResult.addElement(operator);
                    operator= (String) stack.pop();
                }
            }
            else if (isOperator(input))
            {
                String operator= (String) stack.peek();
                while (!operator.equals("#") && compare(operator, input) >= 0)
                {
                    vtResult.addElement(operator);
                    stack.pop();
                    operator= (String) stack.peek();
                }
                stack.push(input);
            }
            else
            {
                vtResult.addElement(input);
            }
        }
        String opr= (String) stack.pop();
        while (!opr.equals("#"))
        {
            vtResult.addElement(opr);
            opr= (String) stack.pop();
        }
        return vtResult;
    }
    private String eval(Vector vtInfix)
    {
        String result= "0.0";
        Stack stack= new Stack();
        Vector vtPostfix= toPostFix(vtInfix);
		Enumeration enumPT= vtPostfix.elements();
		while (enumPT.hasMoreElements())
        {
            String input= (String) enumPT.nextElement();
//            log(" Input Value ::: "+input);
		    if (isOperator(input))
            {
                String operand2= (String) stack.pop();
                log(" operand2 ::::::::: "+operand2);
		        String operand1= (String) stack.pop();
				log(" operand1 ::::::::: "+operand1);
		        if (operand1.startsWith("'")
                    && operand1.endsWith("'")
                    || operand2.startsWith("'")
                    && operand2.endsWith("'"))
                {
                    stack.push(calculate(operand1, operand2, input));
		        }
                else
                {
                    try
                    {
                        stack.push(calculate(Double.parseDouble(operand1),Double.parseDouble(operand2),input)+ "");
		            }
                    catch (NumberFormatException n)
                    {
                        stack.push(calculate(operand1, operand2, input));
		            }
                }
            }
            else
            {
                stack.push(input);
		    }
        }
        result= (String) stack.pop();
		//if (!stack.empty())
        //throw new Exception("Error while evaluating, " + "probably Invalid Expression");
        
        return result;
    }
    private Vector format(String Infix, HashMap VarList, Integer Occurance)
        throws InterfaceException
    {
        Vector vtResult= new Vector();
        if (Infix == null)
        {
            return vtResult;
        }
        Infix= Infix.trim();
		StringBuffer tempStr= new StringBuffer("");
		char[] InfixArr= Infix.toCharArray();
		int length= InfixArr.length;
		for (int i= 0; i < length; i++)
        {
            char ch= InfixArr[i];
            if (ch == DATE_SYMBOL_CHAR || ch == STRING_SYMBOL_CHAR)
            {
                int end;
                for (end= i + 1; InfixArr[end] != ch && end < length; end++)
                {
                    ;
                }
                tempStr.append(new String(InfixArr, i, end - i + 1));
                i= end;
            }
            else if (
                (i + 1 != length) && isOperator(ch + "" + InfixArr[i + 1]))
            {
                update(tempStr, VarList, vtResult, Occurance);
                vtResult.addElement(ch + "" + InfixArr[i + 1]);
                i++;
            }
            else if (isOperator(ch + "") || ch == '(' || ch == ')')
            {
                update(tempStr, VarList, vtResult, Occurance);
                vtResult.addElement(ch + "");
            }
            else
            {
                tempStr.append(ch + "");
            }
            String tempFn= tempStr.toString().trim();
		    if (tempFn.startsWith("isNull")
                || tempFn.startsWith("nvl")
                || tempFn.startsWith("min(")
                || tempFn.startsWith("toNum")
                || tempFn.startsWith("dateDiff")
				|| tempFn.startsWith("addDate"))
            {
                int endPos= getEndParanthesis(Infix, i);
                tempStr.append(new String(InfixArr, i + 1, endPos - i));
                vtResult.addElement(tempStr.toString().trim());
                tempStr.delete(0, tempStr.length());
		        i= endPos;
            }
        }
		update(tempStr, VarList, vtResult, Occurance);
		vtResult.trimToSize();
		
        StringBuffer strBuf= new StringBuffer("");
		for (int i= 0; i < vtResult.size(); i++)
        {
            strBuf.append(vtResult.elementAt(i));
        }
        return vtResult;
    }
    private double calculate(double operand1, double operand2, String op)
    {
        double result= 0.0;
        int oplen= op.length();
        log(" oplen ::::::::: "+oplen+" operand1::: "+operand1+"operand2 :: "+operand2);
        if (oplen == 1)
        {
            switch (op.charAt(0))
            {
                case '+' :
                    result= operand1 + operand2;
                    break;
                case '-' :
                    result= operand1 - operand2;
                    break;
                case '*' :
                    result= operand1 * operand2;
                    break;
                case '/' :
                    result= operand1 / operand2;
                    break;
                case '^' :
                    result= Math.pow(operand1, operand2);
                    break;
                case '%' :
                    result= operand1 % operand2;
                    break;
                case '<' :
                    result= (operand1 < operand2) ? 1.0 : 0.0;
                    break;
                case '>' :
                    result= (operand1 > operand2) ? 1.0 : 0.0;
                    break;
            }
			log("result Single :::"+result);
        }
        else if (oplen == 2)
        {
            char c1= op.charAt(0);
			log("c1:::::::::: "+ c1);
            char c2= op.charAt(1);
			log("c2 :::::::::: "+ c2);
            if (c1 == '<' && c2 == '=')
            {
                result= (operand1 <= operand2) ? 1.0 : 0.0;
		    }
            else if (c1 == '=' && c2 == '=')
            {
                result= (operand1 == operand2) ? 1.0 : 0.0;
			}
            else if (c1 == '>' && c2 == '=')
            {
                result= (operand1 >= operand2) ? 1.0 : 0.0;
			}
            else if (c1 == '!' && c2 == '=')
            {
                result= (operand1 != operand2) ? 1.0 : 0.0;
			}
            else if (c1 == '&' && c2 == '&')
            {
                result= (operand1 == 1.0 && operand2 == 1.0) ? 1.0 : 0.0;
			}
            else if (c1 == '|' && c2 == '|')
            {
                result= (operand1 == 1.0 || operand2 == 1.0) ? 1.0 : 0.0;
			}
			log("result :::"+result);
        }
        return result;
    }
    private String calculate(String operand1, String operand2, String op)
    {
        String result= "";
		if (operand1.indexOf(STRING_SYMBOL) == -1)
            operand1= STRING_SYMBOL + operand1 + STRING_SYMBOL;
			log("operand1:::::::::::::"+operand1);
        if (operand2.indexOf(STRING_SYMBOL) == -1)
            operand2= STRING_SYMBOL + operand2 + STRING_SYMBOL;
			log("operand2:::::::::::::"+operand2);
        if (op.equals("+"))
        {
            result=STRING_SYMBOL+ operand1.substring(1, operand1.length() - 1)
                    + operand2.substring(1, operand2.length() - 1)
                    + STRING_SYMBOL;
//                    log("STRING_SYMBOL"+STRING_SYMBOL);
		}
        else if (op.equals("=="))
        {
            result= operand1.equals(operand2) ? "1.0" : "0.0";
        }
        else if (op.equals("!="))
        {
            result= operand1.equals(operand2) ? "0.0" : "1.0";
        }
        return result;
    }
    private String calculate(
        GregorianCalendar calendar,
        String operand,
        String op)
    {
        String result= "";
        int addWhat= 0;
        int len= operand.length() - 1;
        char ch= operand.charAt(len);
        int val= Integer.parseInt(operand.substring(0, len));
        switch (ch)
        {
            case 'D' :
            case 'd' :
                addWhat= Calendar.DATE;
                break;
            case 'M' :
            case 'm' :
                addWhat= Calendar.MONTH;
                break;
            case 'Y' :
            case 'y' :
                addWhat= Calendar.YEAR;
                break;
            default :
                }
        if (op.equals("+"))
        {
            calendar.add(addWhat, val);
        }
        else if (op.equals("-"))
        {
            calendar.add(addWhat, 0 - val);
        }
        SimpleDateFormat sdf= new SimpleDateFormat(DATE_FORMAT);
        result= sdf.format(calendar.getTime());
        return DATE_SYMBOL + result + DATE_SYMBOL;
    }
    private String calculate(
        GregorianCalendar date1,
        GregorianCalendar date2,
        String op)
    {
        String result= "";
        java.util.Date dt1= date1.getTime();
        java.util.Date dt2= date2.getTime();
        int diff= dt1.compareTo(dt2);
        int oplen= op.length();
        if (oplen == 1)
        {
            char c1= op.charAt(0);
            switch (c1)
            {
                case '<' :
                    if (diff < 0)
                    {
                        result= "1.0";
                    }
                    else
                    {
                        result= "0.0";
                    }
                    break;
                case '>' :
                    if (diff > 0)
                    {
                        result= "1.0";
                    }
                    else
                    {
                        result= "0.0";
                    }
                    break;
            }
        }
        else if (oplen == 2)
        {
            char c1= op.charAt(0);
            char c2= op.charAt(1);
            if (c1 == '<' && c2 == '=')
            {
                if (diff <= 0)
                {
                    result= "1.0";
                }
                else
                {
                    result= "0.0";
                }
            }
            else if (c1 == '=' && c2 == '=')
            {
                if (diff == 0)
                {
                    result= "1.0";
                }
                else
                {
                    result= "0.0";
                }
            }
            else if (c1 == '>' && c2 == '=')
            {
                if (diff >= 0)
                {
                    result= "1.0";
                }
                else
                {
                    result= "0.0";
                }
            }
        }
        return result;
    }
    private boolean isOperator(String str)
    {
        return ((getPriority(str) > 0) ? true : false);
    }
    private int getPriority(String str)
    {
        int val= 0;
        int strlen= str.length();
        if (strlen > 2)
        {
            return val;
        }
        else if (strlen == 1)
        {
            switch (str.charAt(0))
            {
                case '+' :
                case '-' :
                    val= ARITHMETIC;
                    break;
                case '*' :
                case '/' :
                    val= GEOMETRIC;
                    break;
                case '%' :
                    val= MODULUS;
                    break;
                case '^' :
                    val= EXPONENT;
                    break;
                case '<' :
                case '>' :
                    val= RELATIONAL;
                    break;
            }
        }
        else if (strlen == 2)
        {
            char c1= str.charAt(0);
            char c2= str.charAt(1);
            if ((c1 == '<' && c2 == '=')
                || (c1 == '=' && c2 == '=')
                || (c1 == '>' && c2 == '=')
                || (c1 == '!' && c2 == '='))
            {
                val= RELATIONAL;
            }
            else if ((c1 == '&' && c2 == '&') || (c1 == '|' && c2 == '|'))
            {
                val= LOGICAL;
            }
        }
        return val;
    }
    private int getEndParanthesis(String infix, int startPos)
        throws InterfaceException
    {
        int result= 0, count= 0, i, exprLen= infix.length();
        for (i= startPos; i < exprLen; i++)
        {
            if (infix.charAt(i) == '(')
            {
                count= 1;
                break;
            }
        }
        for (++i; i < exprLen; i++)
        {
            if (infix.charAt(i) == '(')
            {
                count++;
            }
            if (infix.charAt(i) == ')')
            {
                count--;
            }
            if (count == 0)
            {
                result= i;
                break;
            }
        }
        if (result == 0)
        {
            throw new InterfaceException(
                "Paranthesis not properly closed",
                "VC002");
        }
        return result;
    }
    private void update(StringBuffer tempStr,HashMap map,Vector vtResult,Integer Occur)
        throws InterfaceException
    {
    	String temp;
        temp= tempStr.toString();
        temp= temp.trim();
//        log(" temp  :: "+temp);
		if (temp.length() > 0)
        {
            char firstLetter= temp.charAt(0);
//			log(" firstLetter "+firstLetter); 
		    if (Character.isLetter(firstLetter))
            {
//				log(" temp 1 "+temp); 
				temp= (String) getMapData(temp, map, Occur);
//				log(" temp 1 after "+temp);
		    }
            if (temp == null)
            {
            	//temp=" ";
                throw new InterfaceException("update : tempStr is null!!", "");
            }
            vtResult.addElement(temp);
        }
        tempStr.delete(0, tempStr.length());
    }
    private String getMapData(String Var_Name, HashMap VarMap, Integer Occur)
        throws InterfaceException
    {
		
        String result= message.getValue(Var_Name);
		if (result != null)
        {
            return result;
        }
        if (VarMap != null && VarMap.containsKey(Var_Name))
        {
            return (String) VarMap.get(Var_Name);
        }
        return result;
    }
    private String[] getArgs(String str, int argsCount)
    {
        int brackets= 0, i= 0;
        String result[]= new String[argsCount];
        try
        {
            for (int j= 0; j < argsCount; j++)
            {
                StringBuffer tempStr= new StringBuffer("");
                int length= str.length();
                for (i= 0; i < length; i++)
                {
                    char ch= str.charAt(i);
                    if (ch == '(')
                    {
                        brackets++;
                    }
                    if (ch == ')')
                    {
                        brackets--;
                    }
                    if (ch == ',' && brackets == 0)
                    {
                        break;
                    }
                    if (ch == DATE_SYMBOL_CHAR || ch == STRING_SYMBOL_CHAR)
                    {
                        int end= str.indexOf(ch + "", i + 1);
                        tempStr.append(str.substring(i, end + 1));
                        i= end;
                    }
                    else
                    {
                        tempStr.append(ch);
                    }
                }
                result[j]= str.substring(0, i).trim();
                if (j != argsCount - 1)
                {
                    str= str.substring(i + 1);
                }
            }
        }
        catch (Exception e)
        {
            // throw new Exception("Error in getNextArg : " + e.toString());
        }
        return result;
    }
    private int compare(String s1, String s2)
    {
        return (getPriority(s1) - getPriority(s2));
    }
    private String isNull(String str, HashMap map, Integer Occurance)
        throws InterfaceException
    {
        String value= message.getValue(str);
        Vector arrayValue= message.getArrayValue(str);
        Object obj= null;
        if (map != null)
            obj= map.get(str);
        if (value == null && arrayValue == null && obj == null)
            return "1.0";
        str= evaluateFormula(str, map, Occurance);
        return (
            str == null
                || str.length() <= 0
                || str.equals("''")
                || str.equals("##"))
            ? "1.0"
            : "0.0";
    }
    private String getNvl(String str, HashMap map, Integer Occurance)
        throws InterfaceException
    {
        str= evaluateFormula(str, map, Occurance);
        return (str == null || str.length() <= 0 || str.equals("''"))
            ? "0.0"
            : str;
    }
    private double toNum(String str, HashMap map, Integer Occurance)
    {
        String result= "0.0";
        try
        {
            result= evaluateFormula(str, map, Occurance);
            char ch=
                (result != null && result.length() > 0)
                    ? result.charAt(0)
                    : ' ';
            if (ch == '\'')
            {
                result= result.substring(1, result.length() - 1);
            }
        }
        catch (Exception e)
        {
            //logError("Error in toNum method, " + e.toString());
        }
        return Double.parseDouble(result);
    }
    private String getDateDiff(String str, HashMap map, Integer Occurance)
    {
        int diff= 0, extra= 0;
        String what= "", res= "";
        try
        {
            String result[]= getArgs(str, 3);
            GregorianCalendar date1=
                formatDate(evaluateFormula(result[0], map, Occurance));
            GregorianCalendar date2=
                formatDate(evaluateFormula(result[1], map, Occurance));
            what= evaluateFormula(result[2], map, Occurance);
            if (what.equalsIgnoreCase("'D'"))
            {
                return getDatesBetween(date1, date2) + "";
            }
            else if (what.equalsIgnoreCase("'M'"))
            {
                return getMonthsBetween(date2, date1) + "";
            }
            else if (what.equalsIgnoreCase("'Y'"))
            {
                diff= getDateDiff(date2, date1, 'y');
                // else throw new Exception("Invalid date diff attribute");
            }
        }
        catch (Exception e)
        {
            //throw new Exception("Error in getDateDiff method : " +e.toString());
        }
        res= diff + "";
        if (what.equalsIgnoreCase("'M'"))
        {
            res= (diff + (extra / 31.0)) + "";
        }
        return res;
    }
    private double getMonthsBetween(
        GregorianCalendar gc2,
        GregorianCalendar gc1)
    {
        double no_of_months= 0;
        int date_from_great= 0;
        GregorianCalendar temp;
        if (!gc2.after(gc1))
        {
            date_from_great= 1;
            temp= gc1;
            gc1= gc2;
            gc2= temp;
        }
        int to_int_yyyy= gc1.get(Calendar.YEAR);
        int to_int_mm= gc1.get(Calendar.MONTH) + 1;
        int to_int_dd= gc1.get(Calendar.DATE);
        int out_last_to_dd= gc1.getActualMaximum(Calendar.DATE);
        int from_int_yyyy= gc2.get(Calendar.YEAR);
        int from_int_mm= gc2.get(Calendar.MONTH) + 1;
        int from_int_dd= gc2.get(Calendar.DATE);
        int out_last_frm_dd= gc2.getActualMaximum(Calendar.DATE);
        if (from_int_yyyy != to_int_yyyy)
        {
            no_of_months= no_of_months + ((to_int_yyyy - from_int_yyyy) * 12);
        }
        if (from_int_mm != to_int_mm)
        {
            if (from_int_dd == to_int_dd)
            {
                no_of_months= no_of_months + (to_int_mm - from_int_mm);
            }
            else
            {
                if (from_int_dd == out_last_frm_dd)
                {
                    if (to_int_dd == out_last_to_dd)
                    {
                        no_of_months += (to_int_mm - from_int_mm);
                    }
                    else
                    {
                        no_of_months += (to_int_mm - from_int_mm);
                        no_of_months += ((to_int_dd - from_int_dd) / 31.0);
                    }
                }
                else
                {
                    no_of_months += (to_int_mm - from_int_mm);
                    no_of_months += ((to_int_dd - from_int_dd) / 31.0);
                }
            }
        }
        else
        {
            if (from_int_dd != to_int_dd)
            {
                no_of_months= no_of_months + ((to_int_dd - from_int_dd) / 31.0);
            }
        }
        if (date_from_great == 1)
        {
            no_of_months= (0 - no_of_months);
        }
        return no_of_months;
    }
    private long getDatesBetween(GregorianCalendar gc1, GregorianCalendar gc2)
    {
        long no_of_days= 0;
        int date_from_great= 0;
        GregorianCalendar temp;
        if (!gc1.after(gc2))
        {
            date_from_great= 1;
            temp= gc1;
            gc1= gc2;
            gc2= temp;
        }
        java.text.DecimalFormat mDF= new java.text.DecimalFormat("00");
        int to_int_yyyy= gc1.get(Calendar.YEAR);
        int to_int_mm= gc1.get(Calendar.MONTH) + 1;
        int to_int_dd= gc1.get(Calendar.DATE);
        char to_yyyy_mm[]=
            (to_int_yyyy + mDF.format(to_int_mm) + " ").toCharArray();
        int from_int_yyyy= gc2.get(Calendar.YEAR);
        int from_int_mm= gc2.get(Calendar.MONTH) + 1;
        int from_int_dd= gc2.get(Calendar.DATE);
        char from_yyyy_mm[]=
            (from_int_yyyy + mDF.format(from_int_mm) + " ").toCharArray();
        while (Long.parseLong(new String(from_yyyy_mm).trim())
            != Long.parseLong(new String(to_yyyy_mm).trim()))
        {
            switch (from_int_mm)
            {
                case 2 :
                    no_of_days += gc1.isLeapYear(from_int_yyyy)
                        ? 29
                        : 28 - from_int_dd;
                    break;
                case 1 :
                case 3 :
                case 5 :
                case 7 :
                case 8 :
                case 10 :
                case 12 :
                    no_of_days= no_of_days + (31 - from_int_dd);
                    break;
                case 4 :
                case 6 :
                case 9 :
                case 11 :
                    no_of_days= no_of_days + (30 - from_int_dd);
                    break;
            }
            if (from_int_mm == 12)
            {
                from_yyyy_mm=
                    ((Long.parseLong(new String(from_yyyy_mm).trim()) + 100)
                        + " ")
                        .toCharArray();
                from_yyyy_mm[4]= '0';
                from_yyyy_mm[5]= '1';
                from_yyyy_mm[6]= ' ';
                from_int_yyyy++;
                from_int_mm= 0;
            }
            else
            {
                from_yyyy_mm=
                    ((Long.parseLong(new String(from_yyyy_mm).trim()) + 1)
                        + " ")
                        .toCharArray();
            }
            from_int_mm++;
            from_int_dd= 0;
        }
        no_of_days= no_of_days + (to_int_dd - from_int_dd);
        if (date_from_great == 1)
        {
            no_of_days *= -1;
        }
        return no_of_days;
    }
    private int getDateDiff(
        GregorianCalendar gc1,
        GregorianCalendar gc2,
        char ch)
    {
        int elapsed= 0;
        int diffType= 0;
        boolean isDay= false, isMonth= false, isYear= false;
        boolean negative= false;
        GregorianCalendar temp;
        if (ch == 'd')
        {
            diffType= Calendar.DATE;
            isDay= true;
        }
        if (ch == 'm')
        {
            diffType= Calendar.MONTH;
            isMonth= true;
        }
        if (ch == 'y')
        {
            diffType= Calendar.YEAR;
            isYear= true;
        }
        if (!gc2.after(gc1))
        {
            negative= true;
            temp= gc1;
            gc1= gc2;
            gc2= temp;
        }
        gc1.clear(Calendar.MILLISECOND);
        gc2.clear(Calendar.MILLISECOND);
        gc1.clear(Calendar.SECOND);
        gc2.clear(Calendar.SECOND);
        gc1.clear(Calendar.MINUTE);
        gc2.clear(Calendar.MINUTE);
        gc1.clear(Calendar.HOUR_OF_DAY);
        gc2.clear(Calendar.HOUR_OF_DAY);
        if (isMonth)
        {
            elapsed += getDateDiff(gc1, gc2, 'y') * 12;
        }
        GregorianCalendar prevGc1= null;
        if (isMonth || isYear)
        {
            prevGc1= (GregorianCalendar) gc1.clone();
            gc1.add(diffType, 1);
        }
        while (gc1.before(gc2))
        {
            elapsed++;
            prevGc1= (GregorianCalendar) gc1.clone();
            gc1.add(diffType, 1);
        }
        if ((isMonth || isYear) && gc1.equals(gc2))
        {
            elapsed++;
        }
        if (gc1.after(gc2))
        {
            gc1.set(Calendar.DATE, prevGc1.get(Calendar.DATE));
            gc1.set(Calendar.MONTH, prevGc1.get(Calendar.MONTH));
            gc1.set(Calendar.YEAR, prevGc1.get(Calendar.YEAR));
            gc1.set(Calendar.HOUR_OF_DAY, prevGc1.get(Calendar.HOUR_OF_DAY));
            gc1.set(Calendar.MINUTE, prevGc1.get(Calendar.MINUTE));
            gc1.set(Calendar.SECOND, prevGc1.get(Calendar.SECOND));
        }
        if (negative)
        {
            elapsed= 0 - elapsed;
        }
        return elapsed;
    }
    private GregorianCalendar formatDate(String dateOperand)
    {
        try
        {
            SimpleDateFormat sdf=
                new SimpleDateFormat(
                    dateOperand.indexOf(":") >= 0
                        ? DATE_FORMAT
                        : DATE_ONLY_FORMAT);
            GregorianCalendar gc= new GregorianCalendar();
            gc.setTime(
                sdf.parse(dateOperand.substring(1, dateOperand.length() - 1)));
            return gc;
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        return null;
    }
    private double getMin(String str, HashMap map, Integer Occurance)
    {
        return getMinMaxAvg(str, "min", map, Occurance);
    }
    private double getMinMaxAvg(
        String str,
        String doWhat,
        HashMap map,
        Integer Occurance)
    {
        double min= 0.0, max= 0.0, total= 0.0, count= 1, val, result= 0.0;
        boolean minFlag= false, maxFlag= false, avgFlag= false;
        if (doWhat.equals("min"))
        {
            minFlag= true;
        }
        else if (doWhat.equals("max"))
        {
            maxFlag= true;
        }
        else if (doWhat.equals("avg"))
        {
            avgFlag= true;
            //		else throw new Exception("Invalid attribute in getMinMaxAvg method");
        }
        try
        {
            StringTokenizer tokens= new StringTokenizer(str, ",");
            String tokenStr= null;
            try
            {
                tokenStr= tokens.nextToken();
                min= Double.parseDouble(tokenStr);
            }
            catch (NumberFormatException e)
            {
                min= Double.parseDouble(evaluateFormula(str, map, Occurance));
            }
            max= min;
            total= min;
            while (tokens.hasMoreTokens())
            {
                try
                {
                    tokenStr= tokens.nextToken();
                    val= Double.parseDouble(tokenStr);
                }
                catch (NumberFormatException e)
                {
                    val=
                        Double.parseDouble(
                            evaluateFormula(tokenStr, map, Occurance));
                }
                if (min > val)
                {
                    min= val;
                }
                if (max < val)
                {
                    max= val;
                }
                total += val;
                count++;
            }
        }
        catch (Exception e)
        {
            // throw new Exception("Error in getMin" + e.toString());
        }
        if (minFlag)
        {
            result= min;
        }
        if (maxFlag)
        {
            result= max;
        }
        if (avgFlag)
        {
            result= total / count;
        }
        return result;
    }
    private String addDate(String str, HashMap map, Integer Occurance)
    {
        String result= null;
        try
        {
            SimpleDateFormat sdf= new SimpleDateFormat(DATE_FORMAT);
            String argsArr[]= getArgs(str, 3);
            GregorianCalendar date=
                formatDate(evaluateFormula(argsArr[0], map, Occurance));
            int value=
                new Double(evaluateFormula(argsArr[1], map, Occurance))
                    .intValue();
            String where= argsArr[2];
            if (where.equalsIgnoreCase("'d'"))
            {
                date.add(Calendar.DATE, value);
            }
            else if (where.equalsIgnoreCase("'m'"))
            {
                date.add(Calendar.MONTH, value);
            }
            else if (where.equalsIgnoreCase("'y'"))
            {
                date.add(Calendar.YEAR, value);
            }
            result= DATE_SYMBOL + sdf.format(date.getTime()) + DATE_SYMBOL;
        }
        catch (Exception e)
        {
            //			 throw new Exception("Error in addDate method : " + e.toString());
        }
        return result;
    }
    public static void main(String args[]) throws Exception
    {
        InputMessage message= new InputMessage();
        /*message.addVariable("OrderStopDate","'01/16/2003'");
        message.addVariable("OrderStartDate","'02/08/2003'");
        message.addVariable("IsActive","Y");
        message.addVariable("FINAL","1");
        message.addVariable("FINALENDORSEMENTFEE","0.158");
        message.addVariable("minEndFee","15");
        message.addVariable("orderNumber","97");*/
        message.addVariable("mbdPropAdd2", "Abstractor Reference Address2");
        message.addVariable("mbdAbsAdd2", "Abstractor Reference Address2");
        message.addVariable("mbdPropAdd1", "Abstractor Reference Address1");
        message.addVariable("mbdAbsAdd1", "Abstractor Reference Address1");
        HashMap hm= new HashMap();
        //hm.put("orderNumber","97");
        FormulaEvaluator fe= new FormulaEvaluator(message);
        System.out.println(fe.evaluate("( mbdAbsAdd1 == mbdPropAdd1 ) && ( mbdPropAdd2 == mbdAbsAdd2 )"));
        //fe.evaluate("dateDiff('20020707','20030707','d') + dateDiff('20020707','20030707','d')");
        //log(fe.evaluate("isNull(orderNumber)"));
        //log(fe.evaluate("isNull(orderNumber) && isNull(orderNumber) && ()"));
        //log(fe.evaluate("( IsActive == 'N' ) || ((dateDiff('2003-09-08 00:00:00.0',OrderStopDate,'d') <= 0) && (dateDiff(OrderStartDate,'2003-09-08 00:00:00.0','d') <= 0))"));
        //log(fe.evaluate("(dateDiff('01/08/2003',OrderStartDate,'d'))"));
        //log(fe.evaluate("FINAL != 1 && !FINAL"));
        //log(fe.evaluate("FINALENDORSEMENTFEE < minEndFee"));
    }
	private void log(String message)
		{
	//		System.out.println(message);
		}
}
