/*
COPYRIGHT NOTICE

Copyright 2005 Polaris Software Lab Limited. All rights reserved.

These materials are confidential and proprietary to 
Polaris Software Lab Limited and no part of these materials should
be reproduced, published, transmitted or distributed in any form or
by any means, electronic, mechanical, photocopying, recording or 
otherwise, or stored in any information storage or retrieval system
of any nature nor should the materials be disclosed to third parties
or used in any other manner for which this is not authorized, without
the prior express written authorization of Polaris Software Lab Limited.
*/
/*********************************************************************
*
* Module Name         :	BRE
*
* File Name           :	InputMessage.java
*
* Description         :	
*
*           
*
*            Version Control Block
*
* Date        Version		Author               Description
* ---------   --------	 ---------------  ---------------------------
*					
*
*********************************************************************/

import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;
/**
 * This builds the Message by adding 
 * variables and array variables to message HashMap.
 */
public class InputMessage extends Message
{
	/**
	* @roseuid 3AD5758D01A5
	*/
	public InputMessage()
	{
		super.message= new HashMap();
		System.out.println("Super Meassage Loaded :::");
	}
    
	public void removeMessageHashfromSuper()
	{
		if (super.message!=null && super.message.size()>0)
		{
			super.message.clear();
			super.message = null;
		}
	}
    
	/**
	 * This method returns the value of the variable whose name is passed as the input 
	 * parameter. The value is returned as a String object
	 * @param variableName - Name of the variable whose value is to be fetched
	 * @return java.lang.String
	 * @roseuid 3AD564610399
	 */
	public String getValue(String variableName)
	{
		if (variableName == null)
		{
			return null;
		}
		Object obj= message.get(variableName.trim());
		if (obj instanceof String)
					return (String) obj;
		else
			return null;
	}
	
	/**
	 * This method returns the value of the array variable by  passing name as 
	 * parameter . The value is returned as a Vector.
	 * @param variableName - Name of the array variable whose value is to be fetched
	 * @return java.util.Vector
	 * @roseuid 3AD56461039B
	 */
	public Vector getArrayValue(String variableName)
	{
		if (variableName == null)
		{
			return null;
		}
		
		Object obj= message.get(variableName.trim());
		if (obj instanceof Vector)
			return (Vector)obj ;
		  else
			return null;

	}
	/**
	 * This method  add 
	 * variables to the Message HashMap.
	 * @param variableName - Name of the variable
	 * @param variableValue - The value of the variable
	 * @roseuid 3AD5646103A9
	 */
	public void addVariable(String variableName, String variableValue)
	{
		if (variableName != null)
		{
			message.put(variableName, variableValue);
		}				
	}

	/**
	 * This method  add 
	 * array variables to the Message HashMap.
	 * @param variableName - Name of the variable
	 * @param variableValue - Value of the variable. The Vector will  contain 
	 * HashMaps, each HashMap in the vector will represent an array variable
	 * @roseuid 3AD5646103B9
	 */
	public void addArrayVariable(String variableName, Vector variableValue)
	{
		if (variableName != null)
		{
			message.put(variableName, variableValue);
		}
	}
   
	/**
	 * This methods returns a Iterator object which can be used to iterate over the 
	 * variables in the HashMap and retrieve their value
	 * @return java.util.Iterator
	 * @roseuid 3AD5646103C8
	 */
	public Iterator getIterator()
	{
		Set keySet= message.keySet();
		Iterator it= null;
		if (keySet != null)
		{
			it= keySet.iterator();
		}
		return it;
	}
	private void log(String message)
	{
//		System.out.println(message);
//		BRELogger logger= BRELogger.getLogger("Function :: ");
//		logger.setDebugLevel();
//		logger.debug(message);
	}
}
