import java.util.*;
import java.io.*;
import org.apache.velocity.*;
import org.apache.velocity.app.*;

public class RuleClassGenerator {

	static ArrayList classes = new ArrayList();
	static int count = 0;
	static String path = "d:\\bre\\poc\\script\\";


	public static void main(String [] args) {

		String modelFile = null;
		String templateFile = null;
	
		if(args.length <= 1) { 
			modelFile = "conditions_velocity200.txt";
			templateFile = "ruletempl.vm";
		} else {
			modelFile = args[0];
			templateFile = args[1];
		}


		System.out.println(" modelFile = " + modelFile);
		System.out.println(" templateFile = " + templateFile);

	try
	{
		
		RuleClassGenerator rgen = new RuleClassGenerator();
		rgen.start(modelFile, templateFile);

	}
	catch (Exception e)
	{
		e.printStackTrace();
	}
	
	}


	public static void start(String modelFile, String templateFile)
	throws Exception {


	 // Imports XML
	 Reader reader =  new FileReader(modelFile);
		
	 BufferedReader bufferedReader =
					new BufferedReader(reader);

	 count = 0;

	// Read input
	String line;
	while ((line = bufferedReader.readLine()) != null) {


	  count++;
	  ClassDescriptor cl = new ClassDescriptor();
      cl.setName(getRuleName());
      classes.add(cl);

		StringTokenizer stok = new StringTokenizer(line, ",");
		while(stok.hasMoreTokens()) {
			String cond = stok.nextToken();

	//		System.out.println(" condition " + cond);

			cl.setCondition(cond);
			cl.setTrueAction("true");
			cl.setFalseAction("false");


			String nvp = stok.nextToken();
			StringTokenizer nvptok = new StringTokenizer(nvp, "&");
			while(nvptok.hasMoreTokens()) {
				String nvptype = nvptok.nextToken();

				StringTokenizer typetok = new StringTokenizer(nvptype, "^");
				while(typetok.hasMoreTokens()) {
					String nvpair = typetok.nextToken();

			//		System.out.println(" nvpair " + nvpair);


					String atype = typetok.nextToken();
			//		System.out.println(" atype " + atype);


					int ind = nvpair.indexOf("=");
					if(ind > 0) {
						String pname = nvpair.substring(0, ind); 
						String pval = nvpair.substring(ind+1); 

						AttributeDescriptor at3 = new AttributeDescriptor();
				        at3.setName(pname);
						if(atype.equals("STR"))
							at3.setType("String");
						else
							at3.setType("int");

			//			System.out.println(" addAttribute ");
						cl.addAttribute(at3);
	
					}
			}
	
		}


		}

	}

		System.out.println(" classes.size() = " + classes.size());

	  
	  // Generates Java classes source code
	  // by using Apache Velocity
	//  GeneratorUtility utility = new GeneratorUtility();
	  for (int i = 0; i < classes.size(); i++) {

		VelocityContext context = new VelocityContext();
		ClassDescriptor cls = (ClassDescriptor) classes.get(i);

		context.put("class", cls);
	//	context.put("utility", utility);

		Velocity.init();
		Template template = Velocity.getTemplate(templateFile);

		BufferedWriter writer =
		  new BufferedWriter(new FileWriter(path + cls.getName()+".rl"));

		template.merge(context, writer);

		writer.flush();
		writer.close();

		System.out.println("Class " + cls.getName() + " generated!");
	  }

	

}

private static String getRuleName() {

	String name = "rule";
		name += prefixZeros(count);
	
	return name;		
}

	public static  String prefixZeros(int id) {

		String idstr = Integer.toString(id);
		if (idstr.length() == 1) {
			idstr = "00" + idstr;
			return idstr;
		} else if(idstr.length() == 2) {
			idstr = "0" + idstr;
			return idstr;
		} else
			return idstr;
		
	}




}