import java.util.*;
import java.io.*;
import org.apache.velocity.*;
import org.apache.velocity.app.*;

public class RuleEvaluator {

	static ArrayList classes = new ArrayList();
	static int count = 0;
	static String path = "d:\\bre\\poc\\script\\";
	static HashMap params = null;


	static int [] skipList = { 162, 163, 164, 167, 168, 169 };
	static int NUMITERS = 500;

	public static void main(String [] args) {

		String modelFile = null;
		String templateFile = null;
	
		if(args.length <= 1) { 
			modelFile = "conditions_velocity200.txt";
			templateFile = "vclass.vm";
		} else {
			modelFile = args[0];
			templateFile = args[1];
		}


		System.out.println(" modelFile = " + modelFile);
		System.out.println(" templateFile = " + templateFile);

	try
	{
		
		RuleEvaluator reval = new RuleEvaluator();
		reval.start(modelFile, templateFile);

	}
	catch (Exception e)
	{
		e.printStackTrace();
	}
	

	}


	public static void start(String modelFile, String templateFile)
	throws Exception {


	 // Imports XML
	 Reader reader =  new FileReader(modelFile);
		
	 BufferedReader bufferedReader =
					new BufferedReader(reader);

	 count = 0;

	// Read input
	String line;
	while ((line = bufferedReader.readLine()) != null) {

	  count++;
	  ClassDescriptor cl = new ClassDescriptor();
      cl.setName(getRuleName());
      classes.add(cl);

	  params = new HashMap();

		StringTokenizer stok = new StringTokenizer(line, ",");
		while(stok.hasMoreTokens()) {
			String cond = stok.nextToken();

		//	System.out.println(" condition " + cond);

			cl.setCondition(cond);
			cl.setTrueAction("true");
			cl.setFalseAction("false");

			String nvp = stok.nextToken();

		//	System.out.println(" nvp " + nvp);

			StringTokenizer nvptok = new StringTokenizer(nvp, "&");
			while(nvptok.hasMoreTokens()) {
				String nvptype = nvptok.nextToken();

				StringTokenizer typetok = new StringTokenizer(nvptype, "^");
				while(typetok.hasMoreTokens()) {
					String nvpair = typetok.nextToken();

			//		System.out.println(" nvpair " + nvpair);


					String atype = typetok.nextToken();
			//		System.out.println(" atype " + atype);


					int ind = nvpair.indexOf("=");
					if(ind > 0) {
						String pname = nvpair.substring(0, ind); 
						String pval = nvpair.substring(ind+1); 

						AttributeDescriptor at3 = new AttributeDescriptor();
				        at3.setName(pname);
						if(atype.equals("STR"))
							at3.setType("String");
						else
							at3.setType("int");

			//			System.out.println(" addAttribute ");
						cl.addAttribute(at3);

						if(atype.trim().equals("STR"))
							params.put(pname, pval);
						else
							params.put(pname, new Integer(Integer.parseInt(pval)));
	
					}
			}
						

		}


		}

		cl.setParams(params);
	}



		System.out.println(" classes.size() = " + classes.size());

		Velocity.init();


		StringReader [] readers = new  StringReader[classes.size()];
		for (int i = 0; i < classes.size(); i++) {

			if(skipListContains(i+1))
				continue;

			String ruleId = "rule" + prefixZeros(i+1);
	  		// get the velocity template from some storage.
			String template = getTemplate(ruleId);
			readers[i] = new StringReader(template);
		}


	long avgTime = 0;
	long [] totTime = new long[NUMITERS];
	long [] evalTime = new long[classes.size()];
	
	for(int t=0;t<NUMITERS;t++) {

	long timeBef = System.currentTimeMillis();

	  // Generates Java classes source code
	  // by using Apache Velocity
	//  GeneratorUtility utility = new GeneratorUtility();
	  for (int i = 0; i < classes.size(); i++) {


			if(skipListContains(i+1))
				continue;

		long timeBefEval = System.currentTimeMillis();
	
		ClassDescriptor cls = (ClassDescriptor) classes.get(i);

	//	System.out.println(" class Params = " + cls.getParams());

	
			HashMap params = cls.getParams();

			VelocityContext context = new VelocityContext(params);

		//	System.out.println(" template = " + template);

			// Get a template as stream.
			StringWriter vwriter = new StringWriter();
		//	StringReader vreader = new StringReader(template);
			StringReader vreader = readers[i];

	//		System.out.println(" class  " + (i+1));

			context.put("class", cls);
			//	context.put("utility", utility);

		//	System.out.print("			");

			// newly added begin

		
			// ask Velocity to evaluate it.
			boolean result = Velocity.evaluate(context, vwriter, "", vreader);



			String strResult = null;
        	if( result ){
          		strResult = vwriter.getBuffer().toString();
        	}

			long timeAftEval = System.currentTimeMillis();


			evalTime[i] = timeAftEval - timeBefEval; 


	//	System.out.println(" strResult " + strResult);
	// newly added end

	//	System.out.println(" ");


		vwriter.flush();
		vwriter.close();

	  }


 			long timeAft = System.currentTimeMillis();
				
			totTime[t] = timeAft- timeBef;

			System.out.println("total time for " + NUMITERS + " iterations at iter no " + t + " = " + totTime[t]);

	}

			avgTime = sum(totTime)/NUMITERS;
			
			System.out.println(" avg time = " + avgTime);



	

}

private static String getRuleName() {

	String name = "rule";
		name += prefixZeros(count);
	
	return name;		
}

	public static  String prefixZeros(int id) {

		String idstr = Integer.toString(id);
		if (idstr.length() == 1) {
			idstr = "00" + idstr;
			return idstr;
		} else if(idstr.length() == 2) {
			idstr = "0" + idstr;
			return idstr;
		} else
			return idstr;
		
	}

	public static String getTemplate(String ruleId) {

	StringBuffer sbuf = new StringBuffer();


	try
	{
		
		String path="d:\\BRE\\poc\\script\\";
		 // Imports XML


		 Reader reader =  new FileReader(path + ruleId + ".groovy");
		
		BufferedReader bufferedReader =
						new BufferedReader(reader);

		// Read input
		String line;
		while ((line = bufferedReader.readLine()) != null) {
			sbuf.append(line);
			sbuf.append("\n");
		
		}

	}
	catch (Exception e)
	{
		e.printStackTrace();
	}


		return sbuf.toString();




	}


	private static boolean skipListContains(int i) {

		for(int j=0;j<skipList.length;j++) {
			if(skipList[j] == i)
				return true;

		}


		return false;

	}

			public static long sum(long [] la) {
	
		long sum = 0L;
		
		for(int r=0;r<la.length;r++)
			sum += la[r];
	
		return sum;
	}	


}